
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Android应用程序窗口(Activity)窗口对象(Window)创建指南_Android / iVAN</title>

    <meta name="description" content="Android应用程序窗口(Activity)窗口对象(Window)创建指南_Android        在前文中,我们分析了Android应用程序窗口的运行上下文环境的创建过程.由此可知,每一个Activity组件都有一个关联的ContextImpl对象,同时,它还关联有一个Window对象,用来描述一个具体的应用程序窗口.由此又可知,Activity只不过是一个高度抽象的UI组件,它的具体UI实现其实是由其它的一系列对象来实现的.在本文中,我们就将详细分析Android应用程序窗口对象的创建过程.        从前面Android应用程序窗口(Activity)实现框架简要介绍和">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Android应用程序窗口(Activity)窗口对象(Window)创建指南_Android</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>       在前文中，我们分析了Android应用程序窗口的运行上下文环境的创建过程。由此可知，每一个Activity组件都有一个关联的ContextImpl对象，同时，它还关联有一个Window对象，用来描述一个具体的应用程序窗口。由此又可知，Activity只不过是一个高度抽象的UI组件，它的具体UI实现其实是由其它的一系列对象来实现的。在本文中，我们就将详细分析Android应用程序窗口对象的创建过程。</p>
<p>       从前面Android应用程序窗口（Activity）实现框架简要介绍和学习计划一文可以知道，在PHONE平台上，与Activity组件所关联的窗口对象的实际类型为PhoneWindow，后者是从Window类继承下来的。Activity、Window和PhonwWindow三个类的关系可以参考Android应用程序窗口（Activity）实现框架简要介绍和学习计划一文中的图3和图5。为了方便接下来描述类型为PhoneWindow的应用程序窗口的创建过程，我们将这两个图拿过来，如以下的图1和图2所示：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDEyMTIwMzA5MDIxNjMuanBn.jpg"></p>
<p>图1 Activity和Window的类关系图</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDEyMTIwMzA5MDIxNjQuanBn.jpg"></p>
<p>图2 Window和PhoneWindow的类关系图</p>
<p>       上述两个图中所涉及到的类的描述可以参考Android应用程序窗口（Activity）实现框架简要介绍和学习计划一文，本文主要从Android应用程序窗口的创建过程来理解Activity、Window和PhonwWindow三个类的关系。</p>
<p>       从Android应用程序窗口（Activity）的运行上下文环境（Context）的创建过程分析一文又可以知道，与Activity组件所关联的一个PhoneWindow对象是从Activity类的成员函数attach中创建的，如图3所示：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDEyMTIwMzA5MDIxNjUuanBn.jpg"></p>
<p>图3 Android应用程序窗口的创建过程</p>
<p>       这个过程可以分为9个步骤，接下来我们就详细分析每一个步骤。</p>
<p>       Step 1. Activity.attach</p>
<p><u>复制代码</u> 代码如下:</p>
<p>public class Activity extends ContextThemeWrapper <br />implements LayoutInflater.Factory, <br />Window.Callback, KeyEvent.Callback, <br />OnCreateContextMenuListener, ComponentCallbacks { <br />......</p>
<p>private Window mWindow; <br />......</p>
<p>final void attach(Context context, ActivityThread aThread, <br />Instrumentation instr, IBinder token, int ident, <br />Application application, Intent intent, ActivityInfo info, <br />CharSequence title, Activity parent, String id, <br />Object lastNonConfigurationInstance, <br />HashMap&lt;String,Object&gt; lastNonConfigurationChildInstances, <br />Configuration config) { <br />......</p>
<p>mWindow = PolicyManager.makeNewWindow(this); <br />mWindow.setCallback(this); <br />if (info.softInputMode != WindowManager.LayoutParams.SOFT_INPUT_STATE_UNSPECIFIED) { <br />mWindow.setSoftInputMode(info.softInputMode); <br />} <br />......</p>
<p>mWindow.setWindowManager(null, mToken, mComponent.flattenToString()); <br />......</p>
<p>}</p>
<p>...... <br />}</p>
<p>        这个函数定义在文件frameworks/base/core/java/android/app/Activity.java中。<br />
<br />        在前面Android应用程序窗口（Activity）的运行上下文环境（Context）的创建过程分析一文中，我们已经分析过这个函数的实现了，这里我们只关注与应用程序窗口创建相关的代码。</p>
<p>        函数首先调用PolicyManager类的静态成员函数makeNewWindow来创建一个类型为PhoneWindow的应用程序窗口，并且保存在Activity类的成员变量mWindow中。有了这个类型为PhoneWindow的应用程序窗口，函数接下来还会调用它的成员函数setCallback、setSoftInputMode和setWindowManager来设置窗口回调接口、软键盘输入区域的显示模式和本地窗口管理器。</p>
<p>        PhoneWindow类的成员函数setCallback、setSoftInputMode和setWindowManager都是从父类Window继承下来的，因此，接下来我们就继续分析PolicyManager类的静态成员函数makeNewWindow，以及Window类的成员函数setCallback、setSoftInputMode和setWindowManager的实现。</p>
<p>        Step 2. PolicyManager.makeNewWindow</p>
<p><u>复制代码</u> 代码如下:</p>
<p>public final class PolicyManager { <br />private static final String POLICY_IMPL_CLASS_NAME = <br />"com.android.internal.policy.impl.Policy";</p>
<p>private static final IPolicy sPolicy;</p>
<p>static { <br />// Pull in the actual implementation of the policy at run-time <br />try { <br />Class policyClass = Class.forName(POLICY_IMPL_CLASS_NAME); <br />sPolicy = (IPolicy)policyClass.newInstance(); <br />} catch (ClassNotFoundException ex) { <br />throw new RuntimeException( <br />POLICY_IMPL_CLASS_NAME + " could not be loaded", ex); <br />} catch (InstantiationException ex) { <br />throw new RuntimeException( <br />POLICY_IMPL_CLASS_NAME + " could not be instantiated", ex); <br />} catch (IllegalAccessException ex) { <br />throw new RuntimeException( <br />POLICY_IMPL_CLASS_NAME + " could not be instantiated", ex); <br />} <br />}</p>
<p>......</p>
<p>// The static methods to spawn new policy-specific objects <br />public static Window makeNewWindow(Context context) { <br />return sPolicy.makeNewWindow(context); <br />}</p>
<p>...... <br />}</p>
<p>       这个函数定义在文件frameworks/base/core/java/com/android/internal/policy/PolicyManager.java中。</p>
<p>       PolicyManager是一个窗口管理策略类，它在第一次被使用的时候，就会创建一个Policy类实例，并且保存在静态成员变量sPolicy中，以后PolicyManager类的窗口管理策略就是通过这个Policy类实例来实现的，例如，PolicyManager类的静态成员函数makeNewWindow就是通过调用这个Policy类实例的成员函数makeNewWindow来创建一个具体的应用程序窗口的。</p>
<p>       接下来，我们就继续分析Policy类的成员函数makeNewWindow的实现。</p>
<p>       Step 3. Policy.makeNewWindow</p>
<p><u>复制代码</u> 代码如下:</p>
<p>public class Policy implements IPolicy { <br />......</p>
<p>public PhoneWindow makeNewWindow(Context context) { <br />return new PhoneWindow(context); <br />}</p>
<p>...... <br />}</p>
<p>        这个函数定义在文件frameworks/base/policy/src/com/android/internal/policy/impl/Policy.java中。</p>
<p>        Policy类的成员函数makeNewWindow的实现很简单，它只是创建了一个PhoneWindow对象，然后返回给调用者。</p>
<p>        接下来，我们就继续分析PhoneWindow类的构造函数的实现，以便可以了解一个类型为PhoneWindow的应用程序窗口的创建过程。</p>
<p>        Step 4. new PhoneWindow</p>
<p><u>复制代码</u> 代码如下:</p>
<p>public class PhoneWindow extends Window implements MenuBuilder.Callback { <br />......</p>
<p>// This is the top-level view of the window, containing the window decor. <br />private DecorView mDecor;</p>
<p>// This is the view in which the window contents are placed. It is either <br />// mDecor itself, or a child of mDecor where the contents go. <br />private ViewGroup mContentParent; <br />......</p>
<p>private LayoutInflater mLayoutInflater; <br />......</p>
<p>public PhoneWindow(Context context) { <br />super(context); <br />mLayoutInflater = LayoutInflater.from(context); <br />}</p>
<p>...... <br />}</p>
<p>       这个函数定义在文件frameworks/base/policy/src/com/android/internal/policy/impl/PhoneWindow.java中。</p>
<p>       PhoneWindow类的构造函数很简单，它首先调用父类Window的构造函数来执行一些初始化操作，接着再调用LayoutInflater的静态成员函数from创建一个LayoutInflater实例，并且保存在成员变量mLayoutInflater中。这样，PhoneWindow类以后就可以通过成员变量mLayoutInflater来创建应用程序窗口的视图，这个视图使用类型为DecorView的成员变量mDecor来描述。PhoneWindow类还有另外一个类型为ViewGroup的成员变量mContentParent，用来描述一个视图容器，这个容器存放的就是成员变量mDecor所描述的视图的内容，不过这个容器也有可能指向的是mDecor本身。在后面的文章中，我们再详细分析类型为PhoneWindow的应用程序窗口的视图的创建过程。</p>
<p>      Window的构造函数定义在文件frameworks/base/core/java/android/view/Window.java中，它的实现很简单，只是初始化了其成员变量mContext，如下所示：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>public abstract class Window { <br />......</p>
<p>private final Context mContext; <br />......</p>
<p>public Window(Context context) { <br />mContext = context; <br />}</p>
<p>...... <br />}</p>
<p>       从前面的调用过程可以知道，参数context描述的是正在启动的Activity组件，将它保存在Window类的成员变量mContext之后，Window类就可以通过它来访问与Activity组件相关的资源了。</p>
<p>       这一步执行完成之后，回到前面的Step 1中，即Activity类的成员函数attach中，接下来就会继续调用前面所创建的PhoneWindow对象从父类Window继承下来的成员函数setCallback来设置窗口回调接口，因此，接下来我们就继续分析Window类的成员函数setCallback的实现。</p>
<p>       Step 5. Window.setCallback</p>
<p><u>复制代码</u> 代码如下:</p>
<p>public abstract class Window { <br />......</p>
<p>private Callback mCallback; <br />......</p>
<p>/** <br />* Set the Callback interface for this window, used to intercept key <br />* events and other dynamic operations in the window. <br />* <br />* @param callback The desired Callback interface. <br />*/ <br />public void setCallback(Callback callback) { <br />mCallback = callback; <br />}</p>
<p>...... <br />}</p>
<p>        这个函数定义在文件frameworks/base/core/java/android/view/Window.java中。<br />
<br />        正在启动的Activity组件会将它所实现的一个Callback接口设置到与它所关联的一个PhoneWindow对象的父类Window的成员变量mCallback中去，这样当这个PhoneWindow对象接收到系统给它分发的IO输入事件，例如，键盘和触摸屏事件，转发给与它所关联的Activity组件处理，这一点可以参考前面Android应用程序键盘（Keyboard）消息处理机制分析一文。</p>
<p>        这一步执行完成之后，回到前面的Step 1中，即Activity类的成员函数attach中，接下来就会继续调用前面所创建的PhoneWindow对象从父类Window继承下来的成员函数setSoftInputMode来设置应用程序窗口的软键盘输入区域的显示模式，因此，接下来我们就继续分析Window类的成员函数setSoftInputMode的实现。</p>
<p>        Step 6. Window.setSoftInputMode</p>
<p><u>复制代码</u> 代码如下:</p>
<p>public abstract class Window { <br />......</p>
<p>private boolean mHasSoftInputMode = false; <br />......</p>
<p>public void setSoftInputMode(int mode) { <br />final WindowManager.LayoutParams attrs = getAttributes(); <br />if (mode != WindowManager.LayoutParams.SOFT_INPUT_STATE_UNSPECIFIED) { <br />attrs.softInputMode = mode; <br />mHasSoftInputMode = true; <br />} else { <br />mHasSoftInputMode = false; <br />} <br />if (mCallback != null) { <br />mCallback.onWindowAttributesChanged(attrs); <br />} <br />}</p>
<p>...... <br />}</p>
<p>       这个函数定义在文件frameworks/base/core/java/android/view/Window.java中。<br />
<br />       参数mode有SOFT_INPUT_STATE_UNSPECIFIED、SOFT_INPUT_STATE_UNCHANGED、SOFT_INPUT_STATE_HIDDEN、SOFT_INPUT_STATE_ALWAYS_HIDDEN、SOFT_INPUT_STATE_VISIBLE和SOFT_INPUT_STATE_ALWAYS_VISIBLE一共六个取值，用来描述窗口的软键盘输入区域的显示模式，它们的含义如下所示：</p>
<p>      1. <strong>SOFT_INPUT_STATE_UNSPECIFIED</strong>：没有指定软键盘输入区域的显示状态。</p>
<p>      2. <strong>SOFT_INPUT_STATE_UNCHANGED</strong>：不要改变软键盘输入区域的显示状态。</p>
<p>      3. <strong>SOFT_INPUT_STATE_HIDDEN</strong>：在合适的时候隐藏软键盘输入区域，例如，当用户导航到当前窗口时。</p>
<p>      4. <strong>SOFT_INPUT_STATE_ALWAYS_HIDDEN</strong>：当窗口获得焦点时，总是隐藏软键盘输入区域。</p>
<p>      5. <strong>SOFT_INPUT_STATE_VISIBLE</strong>：在合适的时候显示软键盘输入区域，例如，当用户导航到当前窗口时。</p>
<p>      6. <strong>SOFT_INPUT_STATE_ALWAYS_VISIBLE</strong>：当窗口获得焦点时，总是显示软键盘输入区域。</p>
<p>      当参数mode的值不等于SOFT_INPUT_STATE_UNSPECIFIED时，就表示当前窗口被指定软键盘输入区域的显示模式，这时候Window类的成员函数setSoftInputMode就会将成员变量mHasSoftInputMode的值设置为true，并且将这个显示模式保存在用来描述窗口布局属性的一个WindowManager.LayoutParams对象的成员变量softInputMode中，否则的话，就会将成员变量mHasSoftInputMode的值设置为false。</p>
<p>      设置完成窗口的软键盘输入区域的显示模式之后，如果Window类的成员变量mCallback指向了一个窗口回调接口，那么Window类的成员函数setSoftInputMode还会调用它的成员函数onWindowAttributesChanged来通知与窗口所关联的Activity组件，它的窗口布局属性发生了变化。</p>
<p>       这一步执行完成之后，回到前面的Step 1中，即Activity类的成员函数attach中，接下来就会继续调用前面所创建的PhoneWindow对象从父类Window继承下来的成员函数setWindowManager来设置应用程序窗口的本地窗口管理器，因此，接下来我们就继续分析Window类的成员函数setWindowManager的实现。</p>
<p>       Step 7. Window.setWindowManager</p>
<p><u>复制代码</u> 代码如下:</p>
<p>public abstract class Window { <br />......</p>
<p>private WindowManager mWindowManager; <br />private IBinder mAppToken; <br />private String mAppName; <br />......</p>
<p>public void setWindowManager(WindowManager wm, <br />IBinder appToken, String appName) { <br />mAppToken = appToken; <br />mAppName = appName; <br />if (wm == null) { <br />wm = WindowManagerImpl.getDefault(); <br />} <br />mWindowManager = new LocalWindowManager(wm); <br />}</p>
<p>...... <br />}</p>
<p>       这个函数定义在文件frameworks/base/core/java/android/view/Window.java中。</p>
<p>       参数appToken用来描述当前正在处理的窗口是与哪一个Activity组件关联的，它是一个Binder代理对象，引用了在ActivityManagerService这一侧所创建的一个类型为ActivityRecord的Binder本地对象。从前面Android应用程序的Activity启动过程简要介绍和学习计划一系列文章可以知道，每一个启动起来了的Activity组件在ActivityManagerService这一侧，都有一个对应的ActivityRecord对象，用来描述该Activity组件的运行状态。这个Binder代理对象会被保存在Window类的成员变量mAppToken中，这样当前正在处理的窗口就可以知道与它所关联的Activity组件是什么。</p>
<p>       参数appName用来描述当前正在处理的窗口所关联的Activity组件的名称，这个名称会被保存在Window类的成员变量mAppName中。</p>
<p>       参数wm用来描述一个窗口管理器。从前面的调用过程可以知道， 这里传进来的参数wm的值等于null，因此，函数首先会调用WindowManagerImpl类的静态成员函数getDefault来获得一个默认的窗口管理器。有了这个窗口管理器之后，函数接着再使用它来创建一个本地窗口管理器，即一个LocalWindowManager对象，用来维护当前正在处理的应用程序窗口。</p>
<p>       接下来，我们首先分析WindowManagerImpl类的静态成员函数getDefault的实现，接着再分析本地窗口管理器的创建过程，即LocalWindowManager类的构造函数的实现。</p>
<p>       Step 8. WindowManagerImpl.getDefault</p>
<p><u>复制代码</u> 代码如下:</p>
<p>public class WindowManagerImpl implements WindowManager { <br />......</p>
<p>public static WindowManagerImpl getDefault() <br />{ <br />return mWindowManager; <br />}</p>
<p>......</p>
<p>private static WindowManagerImpl mWindowManager = new WindowManagerImpl(); <br />}</p>
<p>       这个函数定义在文件frameworks/base/core/java/android/view/WindowManagerImpl.java中。</p>
<p>       WindowManagerImpl类的静态成员函数getDefault的实现很简单，它只是将静态成员变量mWindowManager所指向的一个WindowManagerImpl对象返回给调用者，这个WindowManagerImpl对象实现了WindowManager接口，因此，它就可以用来管理应用程序窗口。</p>
<p>      这一步执行完成之后，回到前面的Step 7中，即Window类的成员函数setWindowManager中，接下来就会使用前面所获得一个WindowManagerImpl对象来创建一个本地窗口管理器，即一个LocalWindowManager对象。</p>
<p>      Step 9. new LocalWindowManager</p>
<p><u>复制代码</u> 代码如下:</p>
<p>public abstract class Window { <br />......</p>
<p>private final Context mContext; <br />......</p>
<p>private class LocalWindowManager implements WindowManager { <br />LocalWindowManager(WindowManager wm) { <br />mWindowManager = wm; <br />mDefaultDisplay = mContext.getResources().getDefaultDisplay( <br />mWindowManager.getDefaultDisplay()); <br />}</p>
<p>......</p>
<p>private final WindowManager mWindowManager;</p>
<p>private final Display mDefaultDisplay; <br />}</p>
<p>...... <br />}</p>
<p>       这个函数定义在文件frameworks/base/core/java/android/view/Window.java中。</p>
<p>       LocalWindowManager类的构造函数首先将参数wm所描述的一个WindowManagerImpl对象保存它的成员变量mWindowManager中，这样以后就将窗口管理工作交给它来处理。</p>
<p>       LocalWindowManager类的构造函数接着又通过成员变量mWindowManager所描述的一个WindowManagerImpl对象的成员函数getDefaultDisplay来获得一个Display对象，用来描述系统屏幕属性。</p>
<p>       由于前面所获得的Display对象描述的是全局的屏幕属性，而当前正在处理的窗口可能配置了一些可自定义的屏幕属性，因此，LocalWindowManager类的构造函数需要进一步地调整前面所获得的Display对象所描述的屏幕属性，以便可以适合当前正在处理的窗口使用。LocalWindowManager类的构造函数首先通过外部类Window的成员变量mContext的成员函数getResources来获得一个Resources对象，接着再调用这个Resources对象的成员函数getDefaultDisplay来调整前面所获得的Display对象所描述的屏幕属性。最终调整完成的Display对象就保存在LocalWindowManager类的成员变量mDefaultDisplay中。</p>
<p>       从前面的Step 4可以知道，类Window的成员变量mContext描述的是与当前窗口所关联的一个Activity组件。Activity类的成员函数getResources是从父类ContextWrapper继续下来的，它实现在文件frameworks/base/core/java/android/content/ContextWrapper.java中，如下所示：</p>
<p><u>复制代码</u> 代码如下:</p>
<p>public class ContextWrapper extends Context { <br />Context mBase; <br />......</p>
<p>@Override <br />public Resources getResources() <br />{ <br />return mBase.getResources(); <br />}</p>
<p>...... <br />}</p>
<p>       从前面Android应用程序窗口（Activity）的运行上下文环境（Context）的创建过程分析一文可以知道，ContextWrapper类的成员变量mBase指向的是一个ContextImpl对象，用来描述一个Activity组件的运行上下文环境。通过调用这个ContextImpl对象的成员函数getResources，就可以获得与一个Resources对象，而通过这个Resources对象，就可以访问一个Activity组件的资源信息，从而可以获得它所配置的屏幕属性。</p>
<p>       至此，我们就分析完成一个Activity组件所关联的应用程序窗口对象的创建过程了。从分析的过程可以知道：</p>
<p>      1. 一个Activity组件所关联的应用程序窗口对象的类型为PhoneWindow。</p>
<p>      2. 这个类型为PhoneWindow的应用程序窗口是通过一个类型为LocalWindowManager的本地窗口管理器来维护的。</p>
<p>      3. 这个类型为LocalWindowManager的本地窗口管理器又是通过一个类型为WindowManagerImpl的窗口管理器来维护应用程序窗口的。</p>
<p>      4. 这个类型为PhoneWindow的应用程序窗口内部有一个类型为DecorView的视图对象，这个视图对象才是真正用来描述一个Activity组件的UI的。</p>
<p>      在接下来的一篇文章中，我们将继续分析应用程序窗口内部的视图对象的创建过程，敬请关注！</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 10:33:44</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/android/" title="android">android</a>, <a href="https://www.iamivan.net/tag/window/" title="window">window</a>, <a href="https://www.iamivan.net/tag/activity/" title="activity">activity</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Android应用程序窗口(Activity)窗口对象(Window)创建指南_Android的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqVmkRp.html" rel="bookmark">Android 应用程序多Activity跳转之后退出整个程序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在应用中肯定遇到有这样的问题,在应用中在于多的Activity中跳转,这些Activity都存在Activity栈中了.所以按返回键的时候都是一个一个的将原来的Activity弹回.如果我们想捕获到back事件之后直接退出整个程序,就要思考了.特别是2.2之后的安全机制考虑之后. 粘贴点代码,以备之后使用. Java代码 package com.jftt;       import Android.app.Activity;    import android.app.ActivityManag			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwKPKRz.html" rel="bookmark">Android使用Theme自定义Activity进入退出动画的方法&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了Android使用Theme自定义Activity进入退出动画的方法.分享给大家供大家参考,具体如下: 有没有觉得Activity的默认动画太快了或者太难看了.. 我原来使用Activity.overridePendingTransition来自定义Activity的进入动画,却发现没法定义退出的动画.结果就发现了强大的Theme和Style,之后还需要好好研究一下. 具体是这样子的: 在AndroidManifest里面,对于application和activity标签可以定义t			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBkVPAM.html" rel="bookmark">Android基于Intent实现Activity之间数据传递的方法&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了Android基于Intent实现Activity之间数据传递的方法.分享给大家供大家参考,具体如下: MainActivity: package com.test.intentdemo; import android.app.Activity; import android.content.Intent; import android.net.Uri; import android.os.Bundle; import android.view.Menu; import andro			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPlJ6Zp.html" rel="bookmark">android使用service和activity获取屏幕尺寸的方法&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了android使用service和activity获取屏幕尺寸的方法.分享给大家供大家参考.具体实现方法如下: 1. activity: DisplayMetrics dm = new DisplayMetrics(); this.getWindowManager().getDefaultDisplay().getMetrics(dm); sW = dm.widthPixels; sH = dm.heightPixels; 2. service: DisplayMetrics dm			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn6W3jp.html" rel="bookmark">Android中通过RxJava进行响应式程序设计的入门指南&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				错误处理 到目前为止,我们都没怎么介绍onComplete()和onError()函数.这两个函数用来通知订阅者,被观察的对象将停止发送数据以及为什么停止(成功的完成或者出错了). 下面的代码展示了怎么使用这两个函数: Observable.just(&quot;Hello, world!&quot;) .map(s -&gt; potentialException(s)) .map(s -&gt; anotherPotentialException(s)) .subscribe(new Subscrib			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pk0gB1z.html" rel="bookmark">简单介绍Android开发中的Activity控件的基本概念&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Activity是最基本的模块,一般称之为&quot;活动&quot;,在应用程序中,一个Activity通常就是一个单独的屏幕.简单理解,Activity代表一个用户所能看到的屏幕,主要用于处理应用程序的整体性工作,例如监听系统事件,为用户显示指定的View,启动其他Activity等.所有应用的Activity都继承于android.app.Activity类,该类是Android提供的基层类,其他的Activity继承该父类后,通过父类的方法来实现各种功能. Activity 生命周期图如下: 在a			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYNwJrp.html" rel="bookmark">Android Studio与SVN版本控制程序的协作使用指南&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				AndroidStudio 的SVN 安装和使用方法与我以前用的其他IDE 都有很大差别,感觉特麻烦,网上相关资料很少,貌似现在 Git 比较流行,之前有用过 github 但是他只能是开源项目免费,下面总结最近自己安装和使用 SVN 的一些经验总结: 如果遇到 ignore 或其他设置无效等意外情况,可以尝试重启 androidstudio 或执行下 svn 的 update 试试 一.安装配置:以前使用 ZendStudio 等等都是直接安装插件就可以了,但这里不行,需要自己独立安装带有 c			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bB1jRkz.html" rel="bookmark">《Android应用开发攻略》&mdash;&mdash;第2章 设计成功的应用程序 2&period;1 导言：设计成功的Android应用程序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第2章 设计成功的应用程序 2.1 导言:设计成功的Android应用程序 Colin Wilcox 讨论 本章介绍编写富于想象力而且实用的Android应用的设计指导思想.有几个攻略描述了成功设计的具体特征.本节将列出其他一些方面. 这一章的目的之一是解释相对于其他在移动设备上交付丰富内容的方法,原生Java Android应用程序开发的好处. 原生手机应用程序的要求 不管在何种平台上部署,成功交付任何手机应用程序都有许多关键的要求: 应用程序应该易于在设备上安装.删除和更新. 应该以引人入胜			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGrrvEp.html" rel="bookmark">Android开发系列二之窗口Activity的生命周期&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在上篇文章给大家介绍了android开发系列一之用按钮实现显示时间,感兴趣的朋友可以点击阅读详情. 在Activity从创建到销毁的过程中需要在不同的阶段调用7个生命周期的方法这7个生命周期方法定义如下: protected void onCreate(Bundle savedInstanceState) protected void onStart() protected void onResume() protected void onPause() protected void onSto			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/4MY4jlb.html" rel="bookmark" class="title">详解CSS3 Media Queries</a>
					<div>
						网页制作Webjx文章简介:说起CSS3的新特性,就不得不提到 Media Queries . 本文比较详细,所以很多实际中用不到.所以如果只是想简单了解Media Queries,推荐参考 CSS3 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM6Q4Lb.html" rel="bookmark" class="title">百度照旧永生</a>
					<div>
						桎梏于一个圈子里,平日接触的大多是和自己志同道合的人,而一旦志同道合,言谈的方向对你来说总是&quot;伟大光荣正确&quot;的,符合你的想法.于是人就会产生一个幻觉,这个国度有一大部分的人和我有类 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp59BWp.html" rel="bookmark" class="title">7大绝招提升网站的质量绝版&excl;</a>
					<div>
						都说网站质量相当重要,这个问题所有做站的朋友都心知肚明,然而很多站长可能还不是很清楚究竟怎么样的一个网站才算是高质量的呢,或者说一个高质量的网站都包括哪些要点呢?因为经常有做站的朋友问我类似这样的问题 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pLQA8z.html" rel="bookmark" class="title">三个月网站排名上首页，小伙伴们惊呆了</a>
					<div>
						说到网站排名很多站长都很头痛吧,特别是百度推出绿萝算法2.0以后,很多站长朋友都说现在外链难收录啊,收录在下降等等,当我听到这些苦水的时候,我就想问问大家你们的网站符合搜索引擎优化标准了吗?很多人的思 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpP3qAM.html" rel="bookmark" class="title">VC&num;数据库编程1</a>
					<div>
						编程|数据|数据库 针对数据库编程始终是程序设计语言的一个重要方面的内容,也是一个难点.数据库编程的内容十分丰富,但最为基本编程的也就是那么几点,譬如:连接数据库.得到需要的数据和针对数据记录的浏览. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW1q3Az.html" rel="bookmark" class="title">Java编程的动态性，第7部分&colon; 用BCEL设计字节码</a>
					<div>
						Apache Byte Code Engineering Library (BCEL)可以深入 Java 类的字节码.可以用它 转换现有的类表示或者构建新的类,因为 BCEL 在单独的 JVM 指令级 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAag6KM.html" rel="bookmark" class="title">PhotoShop中的Camera RAW使用方法详解</a>
					<div>
						对于Camera RAW,很多人也许并不一定很了解,简单的说,它是内置于PhotoShop中,专门处理RAW格式的一个插件.关于它的太多的介绍,我就不说了,因为也没必要说,您只要记住了,用它就可以轻松 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z722Wap.html" rel="bookmark" class="title">让你的表单升级到CSS3和HTML5客户端验证</a>
					<div>
						今天我们一起来看看如何创建一个实用并且功能强大的表单,表单使用如今最热门的技术HTML5和css3来创建,并且可以通过HTML5进行客户端验证. 第一步:策划表单功能 首先,我们得为我们的表单策划一下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MywdEZz.html" rel="bookmark" class="title">linux下输入输出重定向</a>
					<div>
						  inux重定向是指修改原来默认的一些东西,对原来系统命令的默认执行方式进行改变,比如说简单的我不想看到在显示器的输出而是希望输出到某一文件中就可以通过Linux重定向来进行这项工作. Linux默 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWX5y7p.html" rel="bookmark" class="title">win7系统电脑恢复出厂设置激活系统</a>
					<div>
						  现在咱们的很多win7镜像系统电脑笔记本都有了恢复出厂设置,要是我们的电脑发生了一些问题,如果大家选择用恢复出厂设置来解决问题,那么晚咱们的电脑就会回到最初安装win7系统的状态,这样就不用去重装 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWD7Bb.html" rel="bookmark" class="title">Win7系统更新&amp;quot&semi;80246007&amp;quot&semi;错误的解决办法</a>
					<div>
						  系统更新过程中遇到80246007错误是由于BITS服务未开启造成的,具体解决方法如下: [更改或重新启动后台智能传送服务 (BITS) 的步骤] 必须以管理员身份进行登录,才能执行这些步骤: 1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b243J3p.html" rel="bookmark" class="title">有道云笔记各个端支持的分享方式？</a>
					<div>
						  由于笔记各个客户端拥有不同的分享功能,笔记君特地在此详细的列给大家: √:表示客户端已有功能×:表示客户端没有此功能					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7G9AM.html" rel="bookmark" class="title">c&num;之Redis实践list，hashtable</a>
					<div>
						写在前面 最近公司搞了一个活动,用到了redis的队列,就研究了下redis的相关内容.也顺手做了个demo. C#之使用Redis 可以通过Nuget安装Reidis的相关程序集.安装之后发现会引入 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mywjxkz.html" rel="bookmark" class="title">代码重构之路的艰辛</a>
					<div>
						此文属转载,原文链接:http://www.cnblogs.com/viter/archive/2010/11/03/1868377.html 正文如下:   我承认,这个标题很沉重.我有幸使用了一个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjQwjdz.html" rel="bookmark" class="title">ashx是什么文件&comma;如何创建</a>
					<div>
						.ashx 文件用于写web handler的.其实就是带HTML和C#的混合文件.当然你完全可以用.aspx 的文件后缀.使用.ashx 可以让你专注于编程而不用管相关的WEB技术..ashx必须包 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
									<a href="https://www.iamivan.net/a/MqA73eM.html" class="thumbnail">
				<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxMzExMDcxMTM4MDM3MTg/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2YjNWNVlXNW5YM0JsYm1jPS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L1NvdXRoRWFzdA==.jpg">
							</a>
							<div class="info"   >
					<a href="https://www.iamivan.net/a/MqA73eM.html" rel="bookmark" class="title">我的Android进阶之旅------&amp;amp&semi;gt&semi;介绍一款集录制与剪辑为一体的屏幕GIF 动画制作工具 GifCam</a>
					<div>
						由于上一篇文章:我的Android进阶之旅------&gt;Android之动画之Frame Animation实例 中展示的是Frame动画效果,但是之前我是将图片截取下来,不好说明确切的动画过程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkwDL5p.html" rel="bookmark" class="title">亚马逊AWS全球副总裁：云计算市场不会赢家通吃</a>
					<div>
						亚马逊AWS全球市场副总裁艾瑞尔-凯尔曼 腾讯科技 徐安娜 12月16日报道由亚马逊主办的AWS北京技术峰会日前在北京举行.亚马逊宣布在中国推出AWS合作伙伴计划,旨在为技术和咨询合作伙伴提提供业务. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrg6KM.html" rel="bookmark" class="title">【一】ODB - C&plus;&plus; 访问数据库的利器--Hello World On Windows（Version-24）</a>
					<div>
						本文以MySQL数据库为例,其他数据类似. 官方文档和下载 ODB官方首页    官方开发者说明书(开发教程) 安装下载首页(下载与安装教程Windows/Linux) Windows安装步骤(都是英 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze6lk8b.html" rel="bookmark" class="title">word文档-急，高手进！word转pdf问题！</a>
					<div>
						问题描述 急,高手进!word转pdf问题! 用freemarker根据xml生成的word文档,在用openOffer插件转换成pdf.转换成功后pdf打开后显示的是xml的源码 问题应该怎么解决! ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1lKedb.html" rel="bookmark" class="title">搜索引擎用户地区分布</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 据上海艾瑞市场咨询公司所作&lt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWP04p.html" rel="bookmark" class="title">app测试-功能测试如何向自动化过渡</a>
					<div>
						问题描述 功能测试如何向自动化过渡 初入软件测试,最初只能做一些功能测试,不知道最初的功能测试对后期的发展有什么必要的沉淀?以下是我的一些疑问还请大神们能够赐教!!!1.App测试和web测试的发展方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NrGgM.html" rel="bookmark" class="title">Java中JSON的简单使用与前端解析</a>
					<div>
						一.JSON JSON(JavaScript Object Notation) 是一种轻量级的数据交换格式. JSON采用完全独立于语言的文本格式.这些特性使JSON成为理想的数据交换语言.易于人阅读 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeRmONb.html" rel="bookmark" class="title">谷歌&OpenCurlyDoubleQuote;Bug悬赏计划&rdquo;去年颁发200万美元奖金</a>
					<div>
						1月31日消息,据国外科技媒体The Tech Portal的报道,&quot;Bug悬赏计划&quot;正日益流行起来,越来越多的公司选择采用这一方式来排除自己的安全隐患.而已执行此项计划五年的Go ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKlrYb.html" rel="bookmark" class="title">用VS2010编写好网站后，用什么软件进行客户端页面的布局啊？</a>
					<div>
						问题描述 用VS2010编写好网站后,用什么软件进行客户端页面的布局啊? 解决方案 解决方案二:别用VS2010了,改用VS2013吧,2010在文档开关处引入的HTML是XHTML,现在都是HTML ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z40x91z.html" rel="bookmark" class="title">安徽首家市级智慧医院正式揭牌；LG将投5亿美元建 AI 智能家电工厂</a>
					<div>
						京东金融牵手银行根本停不下来,这次是江苏银行 9月28日报道,京东金融与江苏银行在京举行战略合作签约仪式.根据协议,京东金融与江苏银行未来将在消费金融.财富管理.农村金融等多个金融领域展开深度合作,推 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPklgZM.html" rel="bookmark" class="title">大叔也说Xamarin~Android篇~Activity之间传递数组</a>
					<div>
						原文:大叔也说Xamarin~Android篇~Activity之间传递数组 我们在开发应用程序时,不可能只使用一个Layout或者一个Activity,比如你个管理系统,要求用户先登陆然后再使用,这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBg0AAM.html" rel="bookmark" class="title">PostgreSQL里的17种文本相似算法与GIN索引 - pg&lowbar;similarity</a>
					<div>
						标签 PostgreSQL , 文本相似 , pg_similarity , pg_trgm , rum , fuzzymatch gin , smlar 背景 文本相似算法,结合PostgreSQL ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bodPqDM.html" rel="bookmark" class="title">欠债1亿&comma;被法院拉黑的&OpenCurlyDoubleQuote;乐视&rdquo;还如何为梦想窒息？</a>
					<div>
						本文讲的是 : 欠债1亿,被法院拉黑的&quot;乐视&quot;还如何为梦想窒息?   ,   [IT168 评论]一年之前的现在,贾跃亭和乐视发布其上半年度的骄人战绩:营收100.63亿元,同增1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M607oJz.html" rel="bookmark" class="title">inno setup-Inno Setup 卸载向导问题</a>
					<div>
						问题描述 Inno Setup 卸载向导问题 我需要将Inno Setup中的卸载向导设计成带有图片背景的,如何实现啊,安装向导我用 Inno Setup 集成版(原D8团队版)这个版本可以重新设计向 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkAWk7b.html" rel="bookmark" class="title">FreeSwitch SIP（1）：linux下编译安装v1&period;4</a>
					<div>
						本文,原文连接: http://blog.csdn.net/freewebsys/article/details/46546205 ,转载请注明出处! 1,关于FreeSwitch FreeSWITC ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.036 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
